Package: jetpack
Type: Package
Title: A Friendly Package Manager
Version: 0.5.5
Date: 2022-10-30
Authors@R: person("Andrew", "Kane", email = "andrew@chartkick.com", role = c("aut", "cre"))
Description: Manage project dependencies from your DESCRIPTION file. Create a reproducible virtual environment with minimal additional files in your project. Provides tools to add, remove, and update dependencies as well as install existing dependencies with a single function.
URL: https://github.com/ankane/jetpack
BugReports: https://github.com/ankane/jetpack/issues
License: MIT + file LICENSE
RoxygenNote: 7.2.1
Roxygen: list(markdown = TRUE)
Encoding: UTF-8
Imports: renv (>= 0.13.1), remotes (>= 2.0.3), desc (>= 1.2.0), docopt
        (>= 0.4)
Suggests: testthat, withr, packrat
Config/testthat/start-first: cli, global
Author: Andrew Kane [aut, cre]
Maintainer: Andrew Kane <andrew@chartkick.com>
Built: R 4.4.0; ; 2024-04-29 14:27:55 UTC; unix

contains <- function(str, x) {
  grepl(x, str, fixed=TRUE)
}

readFile <- function(file) {
  paste(readLines(file), collapse="")
}

expectContains <- function(name, str) {
  expect(contains(name, str), paste(name, "does not contain", str))
}

refuteContains <- function(name, str) {
  expect(!contains(name, str), paste(name, "contains", str))
}

expectFile <- function(name) {
  expect(file.exists(name), paste(name, "does not exist"))
}

expectFileContains <- function(name, str) {
  expectContains(readFile(name), str)
}

refuteFileContains <- function(name, str) {
  refuteContains(readFile(name), str)
}

context("bioconductor")

test_that("it works", {
  # fails on R-hub Ubuntu
  # possibly due to this warning:
  # 'getOption("repos")' replaces Bioconductor standard repositories
  skip_on_cran()

  setup({
    jetpack::init()

    jetpack::add("BiocManager")
    expectFileContains("DESCRIPTION", "BiocManager")

    jetpack::add("Biobase", remote="bioc::release/Biobase")
    expectFileContains("DESCRIPTION", "Biobase")
    expectFileContains("DESCRIPTION", "bioc::release/Biobase")

    jetpack::remove("Biobase", remote="bioc::release/Biobase")
    jetpack::remove("BiocManager")
  })
})

context("init")

test_that("keeps DESCRIPTION", {
  setup({
    write("Package: app\nImports:\n    DBI", file="DESCRIPTION")

    jetpack::init()

    expectFileContains("DESCRIPTION", "DBI")
  })
})

test_that("can be called multiple times", {
  setup({
    jetpack::init()

    rprofile <- readFile(".Rprofile")

    jetpack::init()

    expect_equal(readFile(".Rprofile"), rprofile)
  })
})

test_that("not initialized", {
  setup({
    expect_error(jetpack::add("DBI"), "This project has not yet been initialized.\nRun 'jetpack::init()' to init.", fixed=TRUE)
  })
})

context("migrate")

library(packrat)

test_that("it works", {
  # fails with unreleased renv versions
  # https://github.com/ankane/jetpack/issues/23
  skip_on_cran()

  setup({
    expect_message(jetpack::migrate(), "This project has not yet been initialized.")

    write("Package: app", file="DESCRIPTION")

    expect_message(jetpack::migrate(), "packrat.lock does not exist.")

    packrat_lock <- "PackratFormat: 1.4
PackratVersion: 0.7.0
RVersion: 4.1.1
Repos: CRAN=https://cloud.r-project.org

Package: DBI
Source: CRAN
Version: 1.1.2
Hash: dd5a8ce809e086244f5cfa75cb68b340

Package: packrat
Source: CRAN
Version: 0.7.0
Hash: 3d49688287bd2246cd8a58e233be39d5
"
    write(packrat_lock, file="packrat.lock")

    expect_error(jetpack::install(), "This project has not yet been migrated to renv.\nRun 'jetpack::migrate()' to migrate.", fixed=TRUE)

    jetpack::migrate()

    expectFile("renv.lock")
    expectFileContains("renv.lock", "DBI")

    # ideally renv::migrate() would exclude packrat
    # but running jetpack::install() fixes it
    # refuteFileContains("renv.lock", "packrat")

    expect_message(jetpack::migrate(), "renv.lock already exists. You should be good to go.")

    jetpack::install()

    refuteFileContains("renv.lock", "packrat")
  })
})

context("local")

test_that("it works", {
  local_path <- Sys.getenv("TEST_JETPACK_LOCAL_PATH", "")
  skip_if(local_path == "")

  setup({
    jetpack::init()

    jetpack::add("dbx", remote=paste0("local::", local_path))
    expectFileContains("DESCRIPTION", "dbx")
  })
})

context("update renv")

test_that("it works", {
  # fails on CRAN r-devel-linux-x86_64-fedora-* with
  # failed to find source for 'renv 0.14.0' in package repositories
  # but passes on R-hub Fedora Linux, R-devel, clang, gfortran
  skip_on_cran()

  setup({
    jetpack::init()

    record <- list(Package="renv", Version="0.15.5", Source="CRAN")
    renv::record(list(renv=record), project=getwd())

    jetpack::install()
    expectFileContains("renv.lock", "0.15.5")

    jetpack::update("renv")
    refuteFileContains("renv.lock", "0.15.5")
  })
})

context("update")

test_that("it works", {
  # fails on CRAN r-devel-linux-x86_64-fedora-* with cannot open URL error
  # but passes on R-hub Fedora Linux, R-devel, clang, gfortran
  skip_on_cran()

  setup({
    jetpack::init()

    expect_error(jetpack::update("DBI"), "Cannot find package 'DBI' in DESCRIPTION file")

    jetpack::add("DBI@1.1.2")
    expectFileContains("DESCRIPTION", "DBI (== 1.1.2)")

    expect_message(jetpack::outdated(), "DBI")

    jetpack::update()
    expectFileContains("DESCRIPTION", "DBI")
    refuteFileContains("DESCRIPTION", "1.1.2")
  })
})

context("github")

test_that("it works", {
  # previously failed on CRAN due to network issue
  # cannot open URL 'https://api.github.com/repos/ankane/dbx/commits/HEAD'
  skip_on_cran()

  setup({
    jetpack::init()

    jetpack::add("dbx", remote="ankane/dbx")
    expectFileContains("DESCRIPTION", "ankane/dbx")

    jetpack::remove("dbx", remote="ankane/dbx")
    refuteFileContains("DESCRIPTION", "ankane/dbx")
  })
})

context("cli")

# must run before any calls to renv::deactivate()
test_that("it works", {
  setup({
    cli <- cliFile()
    jetpack::cli(file=cli)

    output <- run(cli, "init")
    expectContains(output, "Creating virtual environment")
    expectFile("DESCRIPTION")
    expectFile("renv.lock")
    expectFile(".Rprofile")

    output <- run(cli, "add DBI")
    expectContains(output, "Using DBI")
    expectFileContains("DESCRIPTION", "DBI")
    expectFileContains("renv.lock", "DBI")

    output <- run(cli, "check")
    expectContains(output, "All dependencies are satisfied")

    output <- run(cli, "install")
    expectContains(output, "Pack complete")

    output <- run(cli, "install --deployment")
    expectContains(output, "Pack complete")

    output <- run(cli, "update DBI")
    expectContains(output, "Updated DBI")

    output <- run(cli, "update")
    expectContains(output, "All packages are up-to-date")

    # different output based on whether renv is latest
    run(cli, "outdated")

    output <- run(cli, "remove DBI")
    expectContains(output, "Removed DBI")
    refuteFileContains("DESCRIPTION", "DBI")
    refuteFileContains("renv.lock", "DBI")

    # TODO debug
    if (!isWindows()) {
      # TODO test when older version installed
      output <- run(cli, "update renv")
      expectContains(output, "Updated renv")

      output <- run(cli, "outdated")
      expectContains(output, "All packages are up-to-date")
    }

    removeVenv()

    output <- run(cli, "install")
    expectContains(output, "Creating virtual environment")
  }, deactivate=FALSE)
})

context("all")

test_that("it works", {
  setup({
    jetpack::init()
    expectFile("DESCRIPTION")
    expectFile("renv.lock")
    expectFile(".Rprofile")

    jetpack::add("DBI")
    expectFileContains("DESCRIPTION", "DBI")
    expectFileContains("renv.lock", "DBI")

    check <- jetpack::check()
    expect(check, "Check should return true")

    jetpack::install()
    jetpack::install(deployment=TRUE)
    jetpack::update("DBI")
    jetpack::update()

    jetpack::outdated()

    jetpack::remove("DBI")
    refuteFileContains("DESCRIPTION", "DBI")
    refuteFileContains("renv.lock", "DBI")
  })
})

library(withr)

setup <- function(code, deactivate=TRUE) {
  app_dir <- tempfile(pattern="app")
  renv_dir <- tempfile(pattern="renv")
  library_dir <- tempfile(pattern="library")
  venv_dir <- tempfile(pattern="venv")

  dir.create(app_dir)
  dir.create(renv_dir)
  dir.create(library_dir)
  dir.create(venv_dir)

  Sys.setenv(TEST_JETPACK="true")
  Sys.setenv(TEST_JETPACK_ROOT=venv_dir)
  Sys.setenv(RENV_PATHS_ROOT=renv_dir)
  Sys.setenv(RENV_PATHS_LIBRARY_ROOT=library_dir)

  if (deactivate) {
    on.exit(renv::deactivate())
  }

  with_dir(app_dir, code)
}

removeVenv <- function() {
  unlink(Sys.getenv("TEST_JETPACK_ROOT", "none"), recursive=TRUE)
}

context("install deployment")

test_that("it works", {
  setup({
    jetpack::init()

    write("Package: app\nImports:\n    DBI", file="DESCRIPTION")

    expect_error(jetpack::install(deployment=TRUE), "Missing packages: DBI")
  })
})

context("check")

test_that("it works", {
  setup({
    jetpack::init()

    expect_equal(TRUE, jetpack::check())

    write("Package: app\nImports:\n    DBI", file="DESCRIPTION")

    expect_output(jetpack::check(), "Run 'jetpack::install()' to install them", fixed=TRUE)
    expect_equal(FALSE, jetpack::check())
  })
})

isWindows <- function() {
  .Platform$OS.type != "unix"
}

cliFile <- function() {
  ext <- if (isWindows()) ".cmd" else ""
  tempfile(pattern="jetpack", fileext=ext)
}

run <- function(cli, command) {
  debug <- FALSE

  args <- strsplit(command, " ", fixed=TRUE)[[1]]

  if (!isWindows()) {
    # https://stat.ethz.ch/pipermail/r-devel/2018-February/075507.html
    args <- c(cli, args)
    cli <- file.path(R.home("bin"), "Rscript")
  }

  if (debug) {
    cmd <- paste(c(cli, args), collapse=" ")
    cat("\nCommand: ")
    cat(cmd)
  }

  res <- system2(cli, args, stdout=TRUE, stderr=TRUE)
  status <- attr(res, "status")
  output <- paste(res, collapse="\n")

  if (debug) {
    cat("\nOutput:\n")
    cat(output)
  }

  if (!is.null(status)) {
    stop(paste("Command exited with status:", status, "\n", output))
  }

  output
}

context("global")

# must run before any calls to renv::deactivate()
test_that("it works", {
  skip_on_cran()

  skip_if(!identical(Sys.getenv("TEST_JETPACK_GLOBAL"), "true"))

  setup({
    cli <- cliFile()
    jetpack::cli(file=cli)

    output <- run(cli, "global add DBI")
    expectContains(output, "Installed DBI")

    output <- run(cli, "global list")
    expectContains(output, "Using DBI")

    output <- run(cli, "global add DBI@1.1.2")
    expectContains(output, "Installed DBI 1.1.2")

    # TODO figure out remotes error on CI
    # can't convert package rcmdcheck with RemoteType 'any' to remote
    if (!isWindows()) {
      output <- run(cli, "global outdated")
      expectContains(output, "DBI")
    }

    output <- run(cli, "global update DBI")
    expectContains(output, "Updated DBI")

    # TODO figure out remotes error on CI
    # can't convert package rcmdcheck with RemoteType 'any' to remote
    if (!isWindows()) {
      output <- run(cli, "global outdated")
      refuteContains(output, "DBI")
    }

    output <- run(cli, "global remove DBI")
    expectContains(output, "Removed DBI")

    output <- run(cli, "global list")
    refuteContains(output, "Using DBI")
  }, deactivate=FALSE)
})
